/*******************************************************************
*
*  DESCRIPTION: Atomic Model Balancer
*
*  AUTHOR: Changshuang Lin 
*
*  EMAIL: clin@sce.carleton.ca
*  DATE: 16/10/2003
*
*******************************************************************/

#ifndef __BALANCER_H
#define __BALANCER_H

#include <list>
#include "atomic.h"     // class Atomic

class Balancer: public Atomic
{
public:
	Balancer( const string &name = "Balancer" );					//Default constructor

	virtual string className() const ;
protected:
	Model &initFunction();
	Model &externalFunction( const ExternalMessage & );
	Model &internalFunction( const InternalMessage & );
	Model &outputFunction( const InternalMessage & );

private:
	const Port &in;
        Port &out1;
        Port &out2;
        Port &out3;
	Time dispatchTime;
	typedef list<Value> ElementList ;
	ElementList job_queue;
        
};	// class Balancer

// ** inline ** // 
inline
string Balancer::className() const
{
	return "Balancer" ;
}

#endif   //__BALANCER_H
