/*******************************************************************
*
*  DESCRIPTION: Atomic Model DBServer
*
*  AUTHOR: Changshuang Lin 
*
*  EMAIL: clin@sce.carleton.ca
*  DATE: 16/10/2003
*
*******************************************************************/

#ifndef __DBSERVER_H
#define __DBSERVER_H

#include <list>
#include "atomic.h"     // class Atomic

class DBServer: public Atomic
{
public:
	DBServer( const string &name = "DBServer" );					//Default constructor

	virtual string className() const ;
protected:
	Model &initFunction();
	Model &externalFunction( const ExternalMessage & );
	Model &internalFunction( const InternalMessage & );
	Model &outputFunction( const InternalMessage & );

private:
	const Port &in;
	Port &out1;
        Port &out2;
        Port &out3;
	Time dbTime;
	typedef list<Value> ElementList ;
	ElementList job_queue;
	int server_id;
	int jobs_done; // number of jobs finished
        
};	// class DBServer

// ** inline ** // 
inline
string DBServer::className() const
{
	return "DBServer" ;
}

#endif   //__DBSERVER_H
