/*******************************************************************
*
*  DESCRIPTION: Atomic Model Server
*
*  AUTHOR: Changshuang Lin 
*
*  EMAIL: clin@sce.carleton.ca
*  DATE: 16/10/2003
*
*******************************************************************/
#ifndef __SERVER_H
#define __SERVER_H

/** include files **/
#include "atomic.h"  // class Atomic

/** forward declarations **/
class Distribution ;

/** declarations **/
class Server: public Atomic
{
public:
	Server( const string &name = "Server" ) ;	 // Default constructor

	~Server();					// Destructor

	virtual string className() const
		{return "Server";}

protected:
	Model &initFunction()
		{ waiting = false; return *this;}

	Model &externalFunction( const ExternalMessage & );

	Model &internalFunction( const InternalMessage & );

	Model &outputFunction( const InternalMessage & );

private:
	const Port &in ;
	const Port &done ;
	Port &out ;
	Port &db ;
	Distribution *dist ;
	int pid ;
        int pid_sent;
        string server_id;   
 	int id;

        typedef list<Value> ElementList ;
	ElementList job_queue;
	bool waiting;

	Distribution &distribution()
			{return *dist;}
};	// class Server


#endif   //__SERVER_H 
